% Output of this script is the matrix G, where G(i,:,y) is the distribution
% of sizes of the identified set of payoffs for the 'y'th choice, and for
% S=i*100 (S is the number of discretized points of the unobserved dist)
% This matrix G can then be used to directly construct Figure 2 

J=5; %number of iterations
G=zeros(10,J,3);


for i=1:1:10;
    
    % S is the number of discretized points of the unobserved dist
    S=i*100;
    gap=zeros(J,3);

    for j=1:1:J

        % Randomly draw a 3-by-1 vector of choice probabilities
        [p,~] = randfixedsum(3,1,1,0.05,0.95);
        % Size of the identified set of payoffs
        gap(j,:)=sizeset(S,p);

    end
    
    G(i,:,:)=gap;
    
end

    
