%% Store average run-time of MTA in the matrix A

A=[];
it=50; %iterations

%Generate true CCP
[~,~,p,~,~] = IBE(30, 0.9, 2, 0.5, 0.3, 0.35, 0.25, 0.1);

dim=30; %number of states
b = 0.9; % discount factor 

%parameters governing transition of states
theta30 = 0.30; % prob x:+0 
theta31 = 0.35; % prob x:+1 
theta32 = 0.25; % prob x:+2
theta33 = 0.10; % prob x:+3

%transition probability when y=1 
Pi1=zeros(dim,dim);
Pi1(:,1)=theta30*ones(dim,1);
Pi1(:,2)=theta31*ones(dim,1);
Pi1(:,3)=theta32*ones(dim,1);
Pi1(:,4)=theta33*ones(dim,1);

%transition probability when y=2 
Pi2=zeros(dim,dim);
Pi2(1:10,1)=theta30*ones(10,1);
Pi2(1:10,2)=theta31*ones(10,1);
Pi2(1:10,3)=theta32*ones(10,1);
Pi2(1:10,4)=theta33*ones(10,1);


for x=11:1:dim
    
    Pi2(x,x-10)=theta30;
    Pi2(x,x-9)=theta31;
    Pi2(x,x-8)=theta32;
    Pi2(x,x-7)=theta33;
    
end

%transition probability for y=3

Pi3=zeros(dim,dim);

for x=1:1:dim-3
    
    Pi3(x,x)=theta30;
    Pi3(x,x+1)=theta31;
    Pi3(x,x+2)=theta32;
    Pi3(x,x+3)=theta33;
    
end

Pi3(dim-2,dim-2)=(theta30)/(theta30+theta31+theta32);
Pi3(dim-2,dim-1)=(theta31)/(theta30+theta31+theta32);
Pi3(dim-2,dim)=(theta32)/(theta30+theta31+theta32);
Pi3(dim-1,dim-1)=(theta30)/(theta30+theta31);
Pi3(dim-1,dim)=(theta31)/(theta30+theta31);
Pi3(dim,dim)=1;



%p(x,:) is the vector of observed choice probabilities in state x


for S=2000:1000:10000
    tic
    for j=1:1:it
        L=zeros(dim,3);
        parfor x=1:1:dim
            L(x,:)=Gs(p(x,:),S);
        end
        RC=0;
        Vx=(b*Pi3-eye(dim))\(L(:,3)+RC*ones(dim,1));
        u=zeros(dim,2);
        u(:,1)=L(:,1)+Vx-b*Pi1*Vx;
        u(:,2)=L(:,2)+Vx-b*Pi2*Vx;
    end
    et=toc;
    A=[A;et/it]   
end
