%% Store average run-time of SML in the matrix B

%Generate true CCP
[~,~,p,~,~] = IBE(30, 0.9, 2, 0.5, 0.3, 0.35, 0.25, 0.1);

dim=30; %number of states
b = 0.9; % discount factor 

%parameters governing transition of states
theta30 = 0.30; % prob x:+0 
theta31 = 0.35; % prob x:+1 
theta32 = 0.25; % prob x:+2
theta33 = 0.10; % prob x:+3

%transition probability when y=1 
Pi1=zeros(dim,dim);
Pi1(:,1)=theta30*ones(dim,1);
Pi1(:,2)=theta31*ones(dim,1);
Pi1(:,3)=theta32*ones(dim,1);
Pi1(:,4)=theta33*ones(dim,1);

%transition probability when y=2 
Pi2=zeros(dim,dim);
Pi2(1:10,1)=theta30*ones(10,1);
Pi2(1:10,2)=theta31*ones(10,1);
Pi2(1:10,3)=theta32*ones(10,1);
Pi2(1:10,4)=theta33*ones(10,1);


for x=11:1:dim
    
    Pi2(x,x-10)=theta30;
    Pi2(x,x-9)=theta31;
    Pi2(x,x-8)=theta32;
    Pi2(x,x-7)=theta33;
    
end

%transition probability for y=3

Pi3=zeros(dim,dim);

for x=1:1:dim-3
    
    Pi3(x,x)=theta30;
    Pi3(x,x+1)=theta31;
    Pi3(x,x+2)=theta32;
    Pi3(x,x+3)=theta33;
    
end

Pi3(dim-2,dim-2)=(theta30)/(theta30+theta31+theta32);
Pi3(dim-2,dim-1)=(theta31)/(theta30+theta31+theta32);
Pi3(dim-2,dim)=(theta32)/(theta30+theta31+theta32);
Pi3(dim-1,dim-1)=(theta30)/(theta30+theta31);
Pi3(dim-1,dim)=(theta31)/(theta30+theta31);
Pi3(dim,dim)=1;


lb=[1.75,1.75,0.25,0.25];
ub=[2.25,2.25,0.75,0.75];

opts = optimoptions(@fmincon,'Algorithm','active-set','FinDiffRelStep',[0.000005,0.000005,0.000005,0.000005]);

A=[];
B=[];

for S=2000:1000:8000     
    tic
    for i=1:1:50
        s=RandStream('mt19937ar','Seed','shuffle');
        RandStream.setGlobalStream(s);  
        x0=[unifrnd(1.75,2.25,[1,2]),unifrnd(0.25,0.75,[1,2])];   
        x=fmincon(@(b)norm(innerloop(b(1),b(2),b(3),b(4),S,Pi1,Pi2,Pi3)-p),x0,[],[],[],[],lb,ub,[],opts);
        A=[A;[x,x0]]; 
    end  
    et=toc;
    B=[B;[S,et]];
end

B(:,2)=B(:,2)./50; % Average run-time across 50 iterations



